Subject: Are 256K page sizes really a thing (on ppc64le in particular)?

From: Florian Weimer <[email-masked]>
Date: Sat, 28 Sep 2024 18:08:23 +0200

I'm working on adding a <sys/pagesize.h> header to glibc, so that
programmers can easily determine the range of possible page sizes for a
particular target, for things like pointer tagging and mapped file
alignment requirements.

I'm not familiar from the Kconfig system, but as far as I can tell, this
ensures that 256 KiB pages are only available on 44x machines:

arch/powerpc/Kconfig-config PPC_256K_PAGES
arch/powerpc/Kconfig-   bool "256k page size (Requires non-standard binutils settings)"
arch/powerpc/Kconfig-   depends on 44x && !PPC_47x
arch/powerpc/Kconfig:   select HAVE_PAGE_SIZE_256KB

And none of the 44x configurations set 64BIT, so it's all 32-bit.

Would it still make sense to recommend 256 KiB file alignment to
programmers on 32-bit PowerPC, or should <sys/pagesize.h> pretend
that the maximum page size is 64 KiB?

Thanks,
Florian